const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const approval_decisions = sequelize.define(
    'approval_decisions',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

decision: {
        type: DataTypes.ENUM,
      
      

        values: [

"approved",


"rejected"

        ],

      },

decided_at: {
        type: DataTypes.DATE,
      
      

      },

comment: {
        type: DataTypes.TEXT,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  approval_decisions.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity
























































//end loop



    db.approval_decisions.belongsTo(db.approval_requests, {
      as: 'request',
      foreignKey: {
        name: 'requestId',
      },
      constraints: false,
    });

    db.approval_decisions.belongsTo(db.users, {
      as: 'decided_by',
      foreignKey: {
        name: 'decided_byId',
      },
      constraints: false,
    });

    db.approval_decisions.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });




    db.approval_decisions.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.approval_decisions.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return approval_decisions;
};


